'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _array = require('../utils/array');

var beforeNavigate = function beforeNavigate(pages) {
  return pages.filter(function (p) {
    return !p.meta.dismissed;
  });
};

var getCurrentPage = function getCurrentPage(pages) {
  return (0, _array.findLastIndex)(pages, function (item) {
    return !item.meta.dismissed;
  });
};

var onBack = function onBack(pages) {
  var index = (0, _array.findLastIndex)(pages, function (item) {
    return !item.meta.dismissed;
  });
  pages[index].meta.dismissed = true;
  return pages;
};

exports.default = function (base) {
  return _extends({}, base, {
    beforeNavigate: beforeNavigate,
    onBack: onBack,
    getCurrentPage: getCurrentPage
  });
};